package gonganxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type event struct {
	Table
	user   user
	portal string `data:"true"`
	domain string `data:"gonganxitong"`
	list   string `name:"list place_uid uid auto" help:"事件流" icon:"https://img.icons8.com/officel/80/property-with-timer.png"`
}

func (s event) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.user).FieldsWithCreatedAT(m, s,
		model.USER_AVATAR, model.USER_NAME,
		ctx.INDEX, model.OPERATE, ctx.ARGS, model.INFO,
		model.USER_UID,
	)
	if len(arg) == 0 {
		if m.IsTech() {
			s.Select(m)
		}
	} else if len(arg) == 1 {
		s.Select(m, model.PLACE_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, s.Key(s, model.UID), arg[1])
	}
	m.PushAction().Action()
	m.Display("")
}

func init() { ice.TeamCtxCmd(event{}) }

func (s event) Record(m *ice.Message, info string, arg ...string) {
	m.Cmd(s, s.Create, m.OptionSimple(model.USER_UID, model.PLACE_UID), model.INFO, info, ctx.INDEX, m.PrefixKey(), model.OPERATE, m.ActionKey(), ctx.ARGS, kit.Join(arg, ","))
}
