package gonganxitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type place struct {
	Table
	user user
}

func (s place) User(m *ice.Message, arg ...string) {
	userPlace := userPlace{}
	s.Tables(m, "left join user_places on places.uid = user_places.place_uid", s.user).FieldsWithCreatedAT(m, userPlace,
		model.USER_AVATAR, model.USER_NAME, model.BEGIN_TIME, model.END_TIME, model.USER_PLACE_ROLE,
	)
	if len(arg) == 0 {
		if m.IsTech() {
			s.Select(m)
		}
	} else if len(arg) == 1 {
		s.Select(m, model.PLACE_UID, arg[0])
	} else {
		s.SelectDetail(m, model.PLACE_UID, arg[0], s.Key(userPlace, model.UID), arg[1])
	}
	s.RewriteAppend(m)
}
func init() { ice.TeamCtxCmd(place{}) }

type PlaceType int

const (
	PlaceHouse PlaceType = iota
	PlaceHotel
	PlaceStore
	PlacePublic
	PlaceSchool
	PlaceOffice
	PlaceFactory
	PlaceHospital
)

var PlaceTypeList = map[PlaceType]string{
	PlaceHouse:    "house",
	PlaceHotel:    "hotel",
	PlaceStore:    "store",
	PlacePublic:   "public",
	PlaceSchool:   "school",
	PlaceOffice:   "office",
	PlaceFactory:  "factory",
	PlaceHospital: "hospital",
}

func (s PlaceType) String() string { return PlaceTypeList[s] }
